const database = Bun.file('localStorage.json');

if (!await database.exists()) {
    await Bun.write(database, JSON.stringify({}));
}

let data = {};

data = await database.json() || {};

globalThis.localStorage = {
    getItem: (key) => {
        return data[key] || null;
    },
    setItem: (key, value) => {
        data[key] = value;
        Bun.write(database, JSON.stringify(data));
    },
    removeItem: (key) => {
        delete data[key];
        Bun.write(database, JSON.stringify(data));
    },
    clear: () => {
        data = {};
        Bun.write(database, JSON.stringify(data));
    }
};

export { }